=== added symlink 'data/expunge-cache.py'
=== target is '../utils/expunge-cache.py'
=== modified file 'setup.py'
--- setup.py	2012-01-27 10:47:16 +0000
+++ setup.py	2012-02-29 17:23:24 +0000
@@ -94,6 +94,8 @@
                "utils/update-software-center",
                "utils/update-software-center-channels",
                "utils/update-software-center-agent",
+               # generic helpers
+               "utils/expunge-cache.py",
                ] + glob.glob("utils/piston-helpers/*.py"),
       packages=['softwarecenter',
                 'softwarecenter.backend',

=== modified file 'softwarecenter/ui/gtk3/app.py'
--- softwarecenter/ui/gtk3/app.py	2012-02-29 07:15:46 +0000
+++ softwarecenter/ui/gtk3/app.py	2012-02-29 17:23:24 +0000
@@ -390,6 +390,10 @@
             # running the agent will trigger a db reload so we do it later
             GObject.timeout_add_seconds(30, self._run_software_center_agent)
 
+
+        # keep the cache clean
+        GObject.timeout_add_seconds(15, self._run_expunge_cache_helper)
+
         # TODO: Remove the following two lines once we have remove repository
         #       support in aptdaemon (see LP: #723911)
         file_menu = self.builder.get_object("menu1")
@@ -419,6 +423,16 @@
         GObject.child_watch_add(
             pid, self._on_update_software_center_agent_finished)
 
+    def _run_expunge_cache_helper(self):
+        """ helper that expires the piston-mini-client cache """
+        sc_expunge_cache = os.path.join(
+            self.datadir, "expunge-cache.py")
+        (pid, stdin, stdout, stderr) = GObject.spawn_async(
+            [sc_expunge_cache, 
+             "--by-unsuccessful-http-states",
+             softwarecenter.paths.SOFTWARE_CENTER_CACHE_DIR,
+             ])
+
     def _rebuild_and_reopen_local_db(self, pathname):
         """ helper that rebuilds a db and reopens it """
         from softwarecenter.db.update import rebuild_database

